package com.factory.service;

import com.factory.base.entity.task.ApproveEntry;
import com.factory.base.entity.task.FirstCalendar;
import com.factory.base.entity.task.FirstTask;

import java.util.List;
import java.util.Map;

public interface FirstTaskService {

    /**
     * 获取对应的规则
     *
     * @param paarm
     * @return
     */
    public List<FirstCalendar> getCalenderFirstForType(Map<String, Object> param);

    /**
     * 添加当天任务
     *
     * @param task
     * @return
     */
    public int insertFirstTask(FirstTask task);

    /**
     * 需要提醒的工作
     *
     * @param param
     * @return
     */
    public List<FirstCalendar> getRemindWork(Map<String, Object> param);


    /**
     * 更新提醒状态，不太好的写法但是符合现在的需求
     *
     * @param param
     * @return
     */
    public int updateFirstRemindFlag(Map<String, Object> param);


    /**
     * 添加不工作提醒信息
     *
     * @param map
     * @return
     */
    public int addRemindNowork(Map map);

    /**
     * 获取需要提醒人
     *
     * @param map
     * @return
     */
    public Long getRemindNoworkToManager(Map map);

    /**
     * 获取最大审批级别
     *
     * @param map
     * @return
     */
    public int getMaxApproveLevel(Map map);

    /**
     * 或许超时没处理记录
     *
     * @param map
     * @return
     */
    public List<ApproveEntry> getApproveTaskNoDeal(Map map);

    /**
     * 添加新任务处理
     *
     * @param vo
     * @return
     */
    public int addTaskForNext(ApproveEntry vo);
}
